package com.heartland.block;

public class DtTestPointDriver {
	
    //-------------------------------------------------------------------------
    //  DynamicTracar MaskCode
    //-------------------------------------------------------------------------
	static public final int DT_VARIABLE_BIT			=	0x02;				/* Memory Dump MASK */
	static public final int DT_EVTTRG_BIT			=	0x08;				/* EventTrigger MASK */
    static public final boolean file_open			=	false;

    static public DTdrv drv = new DTdrv();

	//-------------------------------------------------------------------------
    //  TestPoint InsertCode Method
    //-------------------------------------------------------------------------
    /* Normal TestPoint Method */
    static public final void DtTestPoint(int nBaseAddress, int nStepNumber){
    	if (file_open == false) {
    		TPOpenFile();
    	}
    	TpBusOut( nBaseAddress, nStepNumber);
    }

    /* Performance TestPoint Method */
    static public final void DtTestPointIdle(int nIdleAddress, int nStepNumber){
        /* Call DynamicTracerDriver */
        TpBusOut(nIdleAddress, nStepNumber);
    }

    /* EventTrigger TestPoint Method */
    static public final void DtTestPointEventTrigger(int nBaseAddress, int nStepNumber, int theValue){
        /* Call DynamicTracerDriver */
        TpEventTrigger(nBaseAddress, theValue);
    }

    /* MemoryOutput TestPoint Method */
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, byte theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 1);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, char theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 2);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, short theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 2);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, int theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 4);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, long theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 8);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, boolean theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 1);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, byte[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 1, nLength);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, char[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 2, nLength);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, short[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 2, nLength);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, int[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 4, nLength);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, long[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 8, nLength);
    }
    static public final void DtTestPointValue(int nBaseAddress, int nStepNumber, boolean[] theValue, int nLength){
        /* Call DynamicTracerDriver */
    	jni.TPMemoryOutput(nBaseAddress, nStepNumber, theValue, 1, nLength);
    }

    /* open file */
    static public final void TPOpenFile() {
    	jni.OpenFile();
    }
    
    /* close file */
    static public final void TpCloseFile() {
    	jni.CloseFile();
    }

    /* Normal TestPoint Method */
    static public final void TpBusOut(int nAddress, int nData){
    	drv.TPBusOut(nAddress, nData);
    }

    /* EventTrigger TestPoint Method */
    static public final void TpEventTrigger(int nAddress, int nData){
        /* DynamicTracerDriver */
    	TpBusOut( nAddress | DT_EVTTRG_BIT , (int)(nData & 0xfff) << 4);
    }
}
